' Archive.bas for FilmStar DESIGN 32 bit
' Copyright 2000 FTG Software Associates

' This program converts FILM files to FILM Archive files.
' Data files should be backed up before using this program!!!!!

Const DataDir$ = "c:\winfilm\data"
Const DesignDir$ = "c:\winfilm\designs"

' The following files should be copied to DataDir$:
'    *.axw, *.flw, *.inw, *.trw, *.vaw

' The following files should be copied to DesignDir$:
'    *.dew

' Path information can be removed. That is, lines in the FILM file
' like "c:\winfilm\mydata\oxides.inw" become "oxides.inw". Path
' information was inserted if the file was stored with the "Save in
' any directory" option in File...Configuration...Directories.

' Since a FILM file is actually a text file, an option is to perform
' a global search and replace to change obsolete file paths to current
' ones. (A programmers's editor is very useful for this task.)

Option Explicit

Sub Main
    If MsgBox ("Remove path names from FILM files?", vbQuestion + vbYesNo,"FILM to FILM Archive") = vbYes Then
        RemoveDirInfo
    End If
    If MsgBox ("Create FILM Archive files?", vbQuestion + vbYesNo,"FILM to FILM Archive") = vbYes Then
        MakeArchive
    End If
End Sub

Sub RemoveDirInfo
    Dim i, k, f$, p$, s$(0 To 6)
    f$ = Dir$(DataDir & "\*.flw")
    While f$ <> ""
        Open DataDir$ & "\" & f$ For Input As #1
      ' i 0 description 1 graph axes  2 film indices  3 design  4 targets  5 variables  6 FILM
        For i=0 To 6
            Input #1, s$(i)
        Next i
        Close #1
        On Error Resume Next    ' in case backups already created
        Name DataDir$ & "\" & f$ As DataDir$ & "\" & Left$(f$,Len(f$)-4) & ".bak"   ' rename as backup
        On Error GoTo 0
        For i= 1 To 5
            GetFilePath s$(i), p$, s$(i) ' remove path names
        Next i
        Open DataDir$ & "\" & f$ For Output As #1   ' re-store files
        For i=0 To 6
            Write #1, s$(i)
        Next i
        Close #1
        f$ = Dir$()
    Wend
End Sub

Sub MakeArchive
    Dim i, k, d$, f$, p$, fName$, s$(0 To 5), ext$(1 To 5)
    ext$(1) = ".axw"
    ext$(2) = ".inw"
    ext$(3) = ".dew"
    ext$(4) = ".trw"
    ext$(5) = ".vaw"
    f$ = Dir$(DataDir & "\*.flw")
    While f$ <> ""
        Open DataDir$ & "\" & f$ For Input As #1
      ' i 0 description 1 graph axes  2 film indices  3 design  4 targets  5 variables
        For i=0 To 5
            Input #1, s$(i)
        Next i
        Close #1
        For i = 1 To 5   ' check for any missing files
            If s$(i) <> "" Then
                GetFilePath s$(i), p$, fName$
                If p$ = "" Then
                    If i=3 Then p$ = DesignDir$ Else p$ = DataDir$
                End If
                If Not(FileExists(p$ & "\" & s$(i) & ext$(i))) Then GoTo NextFile
            End If
        Next i
        k = Macro("FilmOpen " & DataDir$ & "\" & Left$(f$, Len(f$)-4) & ";")
        k = Macro("ArchiveSave " & DesignDir$ & "\" & Left$(f$, Len(f$)-4) & ";")
NextFile:
        f$ = Dir$()
    Wend
End Sub

Sub GetFilePath(ByVal f$, path$, fName$)
    Dim k, r$
    k = InStr(f$, "\")
    If k = 0 Then
        k = InStr(f$, ":")
        If k = 0 Then
            path$ = ""
            fName$ = f$
        Else
            path$ = Mid(f$, 1, 2)
            fName$ = Mid$(f$, 3)
        End If
    Else
        r$ = StrReverse(f$)
        k = Len(f$) - InStr(r$, "\") + 1
        path$ = Mid$(f$, 1, k - 1)
        fName$ = Mid$(f$, k + 1)
    End If
End Sub

Function FileExists(ByVal f$) As Boolean
    On Error GoTo NoFile
    FileExists = (FileLen(f$) > 0)
    Exit Function
NoFile:
    FileExists = False
    Exit Function
End Function
