' Bbhr.bas for FilmStar DESIGN
' Copyright 1995-2001 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Bbhr.bas generates high reflector designs where each layer
' thickness equals the previous thickness multiplied by a ratio.
'
' To run this program as a macro, insert the following under
' Evaluate...Macro...Edit (adjusting if your directory is different)
'
'   Description   BBHR
'   Command       basrun c:\winfilm\basic\bbhr.bas;

Option Explicit
DefInt i-N
DefSng A-H, O-Z
Public Layers
Public qLayer1, qLayer2
Public Symb1$, Symb2$
Const IniSec$ = "BBHR"  ' section in design1.ini

Sub Main
    Dim k
    Layers = Val(IniString(IniSec$, "Layers"))
    If Layers = 0 Then Layers = 50
    qLayer1 = Val(IniString(IniSec$, "Layer1"))
    If qLayer1 = 0 Then qLayer1 = 1
    qLayer2 = Val(IniString(IniSec$, "Layer2"))
    If qLayer2 = 0 Then qLayer2 = .5
    Symb1$ = IniString(IniSec$, "Symbol1")
    If Symb1$="" Then Symb1$ = "H"
    Symb2$ = IniString(IniSec$, "Symbol2")
    If Symb2$="" Then Symb2$ = "L"
    GetDesign
    WriteIniString IniSec$, "Layers", CStr(Layers)
    WriteIniString IniSec$, "Layer1", CStr(qLayer1)
    WriteIniString IniSec$, "Layer2", CStr(qLayer2)
    WriteIniString IniSec$, "Symbol1", Symb1$
    WriteIniString IniSec$, "Symbol2", Symb2$
    Busy False
End Sub

Sub GetDesign
    Dim i, q, Ratio, Des$
    On Error GoTo Quit
    Begin Dialog UserDialog 420,144,"Generate BBHR Design" ' %GRID:6,3,1,1
        Text 30,20,75,15,"   # L&ayers",.Text1
        TextBox 110,17,66,18,.txtLayers 
        Text 30,50,75,15," &First Layer",.Text2
        TextBox 110,47,66,18,.txtFirst
        Text 30,80,75,15," &Last Layer",.Text3
        TextBox 110,77,66,18,.txtLast
        Text 222,20,102,12,"Index Symbol &1",.Text5
        TextBox 330,17,42,18,.txtSym1
        Text 222,50,102,12,"Index Symbol &2",.Text6
        TextBox 330,47,42,18,.txtSym2               
        OKButton 108,111,84,21
        CancelButton 228,111,84,21
    End Dialog
    Dim dlg As UserDialog
    With dlg
        .txtLayers = CStr(Layers)
        .txtFirst = CStr(qLayer1)
        .txtLast = CStr(qLayer2)
        .txtSym1 = Symb1$
        .txtSym2 = Symb2$
    End With
    Dialog dlg
    With dlg
        Layers = Val(.txtLayers)
        qLayer1 = Val(.txtFirst)
        qLayer2 = Val(.txtLast)
        Symb1$ = UCase(.txtSym1)
        Symb2$ = UCase(.txtSym2)
    End With
    ' Calculate the design
    Ratio = (qLayer2/qLayer1)^(1/(Layers-1))
    q = qLayer1
    Des$ = CStr(q) & Symb1$ 
    For i = 2 To Layers
        If i = Layers Then
            q = qLayer2
        Else
            q = q * Ratio
        End If
        Select Case i Mod 2
        Case 0  ' is even layer
            Des$ = Des$ & " " & CStr(q) & Symb2$
        Case 1  ' is odd layer
            Des$ = Des$ & " " & CStr(q) & Symb1$
        End Select  
    Next i
    ' Transfer to FilmStar 
    Design = Des$   
    Exit Sub
Quit:
    End
End Sub
