' BUCK_IR1.BAS for FilmStar DESIGN, MEASURE
' Copyright 1997-2005 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program converts Buck IR .scn spectral data files to FilmStar
' DESIGN/MEASURE .csv format. It stores the new file in the default
' Spectra directory (File...Configuration...Directories). It is similar
' to BUCK_IR2.BAS which loads the spectrum into FilmStar.
'
' To exit the program, click Cancel in the file name dialog

Option Explicit
DefInt i-N
DefSng A-H, O-Z
Option Base 1
Dim sType$, dName$, fName$, file$, path$

Sub Main
    dName$ = IniString("Buck IR", "SpcPath")
    If InStr(UCase$(PgmExe), "DES") > 0 Then  ' DESIGN
        path$ = IniString("Files", "Path4")
    Else
        path$ = IniString("Files", "Path2")
    End If  
    If Right$(path$, 1) <> "\" Then path$ = path$ & "\"         
    Do ' Continue until Cancel button clicked
        OpenFile
    Loop
End Sub

Sub OpenFile
    Dim i
    file$ = GetFilePath$(, "scn", dName$, "Open Buck IR spectrum", 0)
    If file$ = "" Then
        WriteIniString "Buck IR", "SpcPath", dName$
        End
    Else
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)            ' directory
                fName$ = Right$(file$, Len(file$) - i)
                fName$ = Left$(fName$, Len(fName$) - 4) ' file name
                Exit For
            End If
        Next i
        ConvertFile
    End If
End Sub

Sub ConvertFile()
    Dim i, nDat, v, spec, wave, desc$, dayt$, dum$, s$, sf$()
    If fName$ = "" Then Exit Sub
    StatusLabel "Converting " & fName & " - please wait"
    On Error Resume Next
    Begin Dialog UserDialog 460,63,"Select Data Type"
        OptionGroup .optType
            OptionButton 35,22,120,14,"&Reflectance"
            OptionButton 170,22,120,15,"&Transmittance"
        OKButton 330,14,90,28
    End Dialog
    Dim dlg As UserDialog
    If sType$ = "T" Then dlg.optType = 1
    Dialog dlg
    If dlg.optType = 0 Then sType$ = "R" Else sType$ = "T"
    Open file$ For Input As #1

    Open file$ For Input As #1
    Line Input #1, s$
    Line Input #1, desc$
    Line Input #1, dayt$
    Line Input #1, s$

    nDat = Val(s$)
    For i = 1 To 4
        Line Input #1, s$   ' skip 4 lines
    Next i

    ReDim sf$(1 To nDat)

    For i = 1 To nDat
        Line Input #1, sf$(i)
    Next i
    Close #1

    ' The following line stores in same directory as .scn file
    ' Open dName$ & "\" & fName$ & ".csv" For Output As # 1

    ' The following line stores in FilmStar Spectra directory
    Open path$ & fName$ & ".csv" For Output As # 1

    Write #1, "Buck IR: " & desc$ & "(" & dayt$ & ")"
    Write #1, nDat
    For i = 1 To nDat
        Parse sf$(i), dum$, wave, ","
        Parse sf$(i), dum$, spec, ","
        v = spec / 100
        If sType$ = "R" Then
            Write #1, 1.0E+7/wave, v, 0
        Else
            Write #1, 1.0E+7/wave, 0, v
        End If
    Next i
    Close #1
    StatusLabel ""
    Busy False
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub
