'#Reference {00020813-0000-0000-C000-000000000046}#1.3#0#C:\Program Files\Microsoft Office\Office\EXCEL9.OLB#Microsoft Excel 9.0 Object Library
' DialogXL.bas
' FTG Software 13 Feb 06
'
' This program illustrates how an Excel VBA form can be used as
' a data entry screen, replacing the native FilmStar BASIC dialog.
' Compare this with Dialog.bas
'
Option Explicit
'
' ******************** Change as required ********************
'
Const XLDialog As String = PgmPath & "\basic32\DialogXL.xls"
'
' ************************************************************
'
Dim szDate As String, szBatch As String, kID, szSubs As String

Dim xlApp As Excel.Application
Dim xlBookDlg As Excel.Workbook
Dim xlSheetDlg As Excel.Worksheet

Sub Main
    '
	' ***************************************************************
	' If you get an error in the next line, you need to re-establish
	' a reference to the Microsoft Excel Object Library
    ' ***************************************************************
    '
	Set xlApp = New Excel.Application
    xlApp.DisplayAlerts = False	' no save prompt upon exiting Excel
	Set xlBookDlg = xlApp.Workbooks.Open(XLDialog)
	Set xlSheetDlg = xlBookDlg.Sheets(1)

    Do
    Loop Until UserInputOK()
    xlApp.Quit	' Delete Excel process
End Sub

Function UserInputOK() As Boolean
	On Error Resume Next
	' Assign values to spreadsheet
	With xlSheetDlg
        If IsBlank(szDate) Then     ' default is today's date
            .Cells(1, 2) = Right$(CStr(Year(Date)), 2) & Format$(Month(Date), "00") & Format$(Day(Date), "00")
        Else
            .Cells(1, 2) = szDate
	    End If
		.Cells(2, 2) = szBatch
		.Cells(3, 2) = "1"		' starting ID number
        .Cells(4, 2) = "0"
	End With
	' Show the dialog
	xlApp.Run "DataEntry"
	' Get values from spreadsheet
	With xlSheetDlg
		If .Cells(4, 2) = "0" Then GoTo CancelClick	' Cancel clicked in Excel
		szDate = .Cells(1, 2)
		szBatch = .Cells(2, 2)
		kID = CInt(.Cells(3, 2))
	End With
    UserInputOK = True
    If MsgBox("Date: " & szDate & vbLf & "Batch: " & szBatch & vbLf & "Starting ID Number: " & CStr(kID) & _
      vbLf & vbLf & "Are these entries correct?", vbYesNo + vbQuestion, "Verify Input") = vbYes Then
		'
		' Do something useful
		'
    Else
        UserInputOK = False ' re-enter data
    End If
    Exit Function
CancelClick:
    If MsgBox("Exit program?", vbYesNo + vbQuestion, "Excel Dialog Example") = vbYes Then
    	xlApp.Quit
        End
    Else
        UserInputOK = False
    End If
    Exit Function
End Function

Function IsBlank(ByVal a$) As Boolean
    IsBlank = (Len(Trim$(a$)) = 0)
End Function
