' FilmDelete.bas for FilmStar DESIGN
' Copyright 2000-2015 FTG Software Associates

' This program deletes FILM files after conversion to FILM Archive
' !!!!!! USE ONLY AFTER FilmToArchive.bas !!!!!!

Option Explicit
DefLng i-N

' CHANGE DIRECTORIES AS REQUIRED
' VERIFY PATHS IN FILES..CONFIGURATION..DIRECTORIES
Const DataPth$ = "c:\winfilm\data"
Const DesignPth$ = "c:\winfilm\designs"

Sub Main
    Const t$ = "Delete FILM Files"
    If MsgBox("This program deletes FILM files after conversion to FILM Archive format. Proceed at your own risk!", vbOkCancel + vbExclamation, t$) = vbOK Then
        If MsgBox("Have you successfully converted FILM to FILM Archive files?", vbYesNo + vbQuestion + vbDefaultButton2, t$) = vbNo Then
            MsgBox "Run FilmToArchive.bas and return to this program later.", vbOkOnly + vbInformation, t$
        ElseIf MsgBox("Are you sure you want to delete FILM files?", vbYesNo + vbQuestion + vbDefaultButton2, t$) = vbYes Then
            DoDelete
        End If
    End If
End Sub

Sub DoDelete
    Dim i, fa$, film$, p$, s$(0 To 5)
    On Error Resume Next
    fa$ = Dir$(DesignPth$ & "\*.faw")  ' FILM Archive
    While fa$ <> ""
    	On Error GoTo NextFile
        GetFilePath fa$, p$, film$
        film$ = DataPth$ & "\" & Left$(film$, Len(film$)-4)  & ".flw"
        If FileExists(film$) Then
            Open film$ For Input As #1
            StatusLabel "Deleting " & film$
          ' i 0 description 1 graph axes  2 film indices  3 design  4 targets  5 variables
            For i=0 To 5
                Input #1, s$(i)
            Next i
            Close #1
            Kill DataPth$ & "\" & s$(1) & ".axw"
            Kill DataPth$ & "\" & s$(2) & ".inw"
            Kill DesignPth$ & "\" & s$(3) & ".dew"
            Kill DataPth$ & "\" & s$(4) & ".trw"
            Kill DataPth$ & "\" & s$(5) & ".vaw"
            Kill film$
            DoEvents
        End If
NextFile:
        Close
        fa$ = Dir$()
    Wend
End Sub

Sub GetFilePath(ByVal f$, path$, fName$)
    Dim k, r$
    k = InStr(f$, "\")
    If k = 0 Then
        k = InStr(f$, ":")
        If k = 0 Then
            path$ = ""
            fName$ = f$
        Else
            path$ = Mid(f$, 1, 2)
            fName$ = Mid$(f$, 3)
        End If
    Else
        r$ = StrReverse(f$)
        k = Len(f$) - InStr(r$, "\") + 1
        path$ = Mid$(f$, 1, k - 1)
        fName$ = Mid$(f$, k + 1)
    End If
End Sub

Function FileExists(ByVal f$) As Boolean
    On Error GoTo NoFile
    FileExists = (FileLen(f$) > 0)
    Exit Function
NoFile:
    FileExists = False
    Exit Function
End Function

