' IndexSolve.bas for FilmStar DESIGN 32 bit
' Copyright 2000-2015 Software Associates
'    Released 02.10.00
'    Updated  12.21.00  F_Path(7) changed to FilePath(1)
'             03.04.15  Eliminate possible dup target
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
Option Explicit
Option Base 1
DefInt i-n
DefSng a-h, o-z

' Index fit at series of measured wavelengths at different
' angles and polarizations using Index Function $NK
'
' ***********************  Initial Values ***********************
' ********************** Change as Required *********************
Public Const xnstart = .2
Public Const xkstart = 5
Public Const astart = 6     ' 6 deg
Public Const pstart$ = "R"  ' random pol
Public Const IndexRow = 3   ' Film Indices $NK function row #
'                             (Opti Variable = -#)
' ***************************************************************

Public file$
Public ndat, wave(), refl(), trns(), ang(), spol() As String*1
Public NewFlg As Boolean
Public cang, cPol$

Sub Main
    Dim k As Boolean
    cang = astart
    cPol = pstart$
    OptiVars "-" & CStr(IndexRow)   ' specify variable
    Busy False  ' remove hourglass left by OptiVars
    Do
        If ndat > 0 Then
            If MsgBox("Add another data file?", vbYesNo + vbQuestion ,"Open Spectrum") = vbYes Then
                OpenFile
                If file$="" Then Exit Do
            Else
                Exit Do
            End If
        Else
            OpenFile
            If file$="" Then End
        End If
    Loop
    MainActivate
    k = Macro("AxesDraw;")
    ' sort data by wavelength
    SortData wave(), refl(), trns(), ang(), spol()
    Solve
    MsgBox "Index table copied to clipboard", vbOK ,"n,k Calculation"
End Sub

Sub Solve
    Dim i, j, iw, k As Boolean, kp, clip$
    Dim w, xn, xk
    ' ********** Initialize ************
    SetIndexCoeff IndexRow, 1, xnstart     ' starting index values
    SetIndexCoeff IndexRow, 2, xkstart
    NewFlg = True   ' new targets
    kp=1            ' pointer
    Do
        iw=1    ' initialize
        PutTarget iw, kp
        w = wave(kp)
        Do
            If kp=ndat Then
				Optimize
                clip$ = clip$ & Format$(w) & vbTab & Format$(IndexCoeff(IndexRow,1)) & vbTab & Format(IndexCoeff(IndexRow,2)) & vbCrLf
                Clipboard clip$         ' w,n,k values copied to clipboard		
                Exit Sub
            ElseIf wave(kp+iw) = wave(kp) Then
                NewFlg = False
                iw=iw+1
                PutTarget iw, kp
                If kp+iw-1 = ndat Then 
                    Optimize
                    clip$ = clip$ & Format$(w) & vbTab & Format$(IndexCoeff(IndexRow,1)) & vbTab & Format(IndexCoeff(IndexRow,2)) & vbCrLf
                    Clipboard clip$     ' w,n,k values copied to clipboard
                    Exit Sub
                End If
            Else
                Exit Do
            End If
        Loop
        kp=kp+iw
        NewFlg = True
        ' Optimization is setup to use function $NK for film in IndexRow
        k = Optimize
        clip$ = clip$ & Format$(w) & vbTab & Format$(IndexCoeff(IndexRow,1)) & vbTab & Format(IndexCoeff(IndexRow,2)) & vbCrLf
    Loop
End Sub

Sub PutTarget(iw, kp)
    Dim j
    ReDim w(1), y(1, 2)
    j = iw+kp-1
    w(1) = wave(j)
    y(1, 1) = refl(j)
    y(1, 2) = trns(j)
    Spectrum_X = w
    Spectrum_Y = y
    SpecTargets NewFlg, "R", 1, ang(j), spol(j)
    SpecTargets False, "T", 1, ang(j), spol(j)
End Sub

Sub OpenFile
    Dim i, j, k, n, a$, desc$, dum$, s$, xdum
    s$ = FilePath(1)    ' get default path...change as required
    file$ = GetFilePath$(,"csv", FilePath(1), "Open FilmStar .csv spectrum", 0)
    If file$ <> "" Then
        a$ = InputBox("Angle and polarization (pol=RPS, i.e. 45 R)?","IndexSolve",Format$(cang) & " " & cPol)
        If a$ = "" Then End
        Parse a$, dum$, cang, " "
        cPol = UCase$(a)
        Open file$ For Input As #1
        Line Input #1, desc$
        Input #1, n     ' # of points in file
        If ndat = 0 Then
            ReDim wave(n), refl(n), trns(n), ang(n), spol(n)
        Else
            ReDim Preserve wave(n+ndat), refl(n+ndat), trns(n+ndat), ang(n+ndat), spol(n+ndat)
        End If
        For i=1 To n
            j = ndat + i
            Input #1, wave(j), refl(j), trns(j)
            ang(j) = cang   ' angle of incidence
            spol(j) = cPol
        Next i
        Close #1
        ndat = n+ndat
    End If
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub

Sub psortn(v(), l())
    Dim i, j, k, kother, krun, lbd, l1, l2, q, vi, vj, vk, z%, zz%, ubd%
    lbd = LBound(l): ubd = UBound(l) ' we use bounds of l() to index v()
    If ubd <= lbd Then
        If ubd < lbd Then Exit Sub
        l(lbd) = lbd
        Exit Sub
    End If
    z = lbd - 1: zz = 2 * z
    l2 = lbd: l1 = l2 + 1
    If v(l1) < v(l2) Then
        l1 = l2: l2 = l1 + 1
    End If
    krun = l1: kother = l2
    vj = v(l1): vk = v(l1)
    For i = lbd + 2 To ubd
        vi = v(i)
        If vi < vj Then
            If vi >= v(l2) Then
                l(i) = l1: l1 = i
            Else
                l(i) = l(l2): l(l2) = l1: l1 = l2
                If kother = l2 Then kother = i
                l2 = i
            End If
            vj = v(l1)
        Else
            If vi >= vk Then
                l(krun) = i
            Else
                l(kother) = zz - i: kother = krun
            End If
            krun = i
            vk = vi
        End If
    Next i
    l(krun) = z: l(kother) = z
    l(l1) = zz - l(l1)
    Do
        i = l(l1): j = l(l2)
        If j = z Then Exit Do
        krun = l1: kother = l2
        Do
            i = zz - i: j = zz - j: vi = v(i): vj = v(j): k = krun
            Do
                If vi <= vj Then
                    l(k) = i: k = i: i = l(i)
                    If i <= z Then
                        l(k) = j
                        Do
                            k = j: j = l(j)
                        Loop While j > z
                        Exit Do
                    End If
                    vi = v(i)
                Else
                    l(k) = j: k = j: j = l(j)
                    If j <= z Then
                        l(k) = i
                        Do
                            k = i: i = l(i)
                        Loop While i > z
                        Exit Do
                    End If
                    vj = v(j)
                End If
            Loop
            l(krun) = zz - l(krun): krun = kother: kother = k
        Loop Until j = z
        l(krun) = i: l(kother) = z
    Loop
    l(l2) = l1: l(l1) = zz - l(l1): i = l2
    For j = zz - lbd To zz - ubd Step -1
        k = l(l2): l(l2) = j: l2 = k
    Next j
    For i = lbd To ubd
        j = l(i)
        If j < z Then
            j = zz - j
            Do
                q = zz - l(j): l(j) = k: k = j: j = q
            Loop While j > z
        End If
    Next i
End Sub

Sub SortData(x(), y1(), y2(), a(), p() As String*1)
    Dim i, j, n
    n = UBound(x)
    ReDim xtmp(n), y1tmp(n), y2tmp(n), atmp(n), ptmp(n) As String*1,kSort(n)
    For i = 1 To n
        xtmp(i) = x(i)
        y1tmp(i) = y1(i)
        y2tmp(i) = y2(i)
        atmp(i) = a(i)
        ptmp(i) = p(i)
    Next i
    psortn x(), kSort()
    For i = 1 To n
        'j = i       ' Forward order
        j = n-i+1    ' Reverse order - better for index fitting
        x(i)  = xtmp(kSort(j))
        y1(i) = y1tmp(kSort(j))
        y2(i) = y2tmp(kSort(j))
        a(i) = atmp(kSort(j))
        p(i) = ptmp(kSort(j))
    Next i
End Sub
