' InHomog.bas for FilmStar DESIGN 32 bit
' Copyright 2001 Software Associates
'
' This program creates inhomogeneous index profiles according
' to user-supplied formulas
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
Option Explicit
Option Base 1
DefInt i-N
DefSng A-H, O-Z
Dim sIndex$
Dim xMin, xMax, nStep, Symb1$, kPhys, kFunc, kOpti
Dim nTabs

Sub Main
    Dim i, kAdd, dum, nTab, kStart As Boolean, lin$(3), s$
    ' some starting values
    xMin = 1.8
    xMax = 2.2
    Symb1$ = "A"  ' starting index symbol
    nStep = 6     ' no of steps ex 6: A B C D E F
    kPhys = 1     ' 0 optical thickness, 1 physical thickness
    kFunc = 0     ' 0 linear, 1 parabolic...add functions as required
    Do
        If kAdd = 0 Then
            s$="Add film indices to Film Indices editor?"
        Else
            s$="Add more film indices to Film Indices editor?"
        End If
        If MsgBox(s$, vbQuestion + vbYesNo, "Inhomogeneous") = vbYes Then
            If GetIndices() Then
                If Not kStart Then
                    Design = ""  ' clear design in order to prevent possible error
                    IndexCopy
                    sIndex = Clipboard$()
                    For i=1 To 3
                        Parse sIndex, lin$(i), dum, vbCrLf
                    Next i
                    ' number of tabs in line...will give us dimension
                    nTabs = Occurences(lin$(1), vbTab)
                    ' this saves substrate indices and clears film indices
                    sIndex = lin$(1) & vbCrLf & lin$(2) & vbCrLf & lin$(3) & vbCrLf
                    kStart=True
                End If
                If kOpti Then s$ = "$N" Else s$ = ""
                For i = 1 To nStep
                    sIndex = sIndex & Chr$(Asc(Symb1$)+i-1) & vbTab
                    Select Case kPhys
                    Case 0  ' optical
                        sIndex = sIndex & " " & vbTab & s$ & vbTab
                    Case 1  ' physical
                        sIndex = sIndex & "*" & vbTab & s$ & vbTab
                    End Select
                    ' ********************************************
                    '          edit/add user-formulas here
                    Select Case kFunc
                    Case 0  ' linear
                        sIndex = sIndex & Format$(xMin+(i-1)/(nStep-1)*(xMax-xMin), "0.00000")
                    Case 1  ' parabolic
                        sIndex = sIndex & Format$(xMin+Sqr((i-1)/(nStep-1)*(xMax-xMin)^2), "0.00000")
                    End Select
                    ' ********************************************
                    sIndex = sIndex & String$(nTabs-3, vbTab) & vbCrLf
                Next i
                kAdd = kAdd + 1
            End If
        Else    ' Done
            If kStart Then
                Clipboard$ sIndex
                IndexPaste
            End If
            Busy False
            End
        End If
    Loop
End Sub

Function GetIndices() As Boolean
    Dim i
    On Error GoTo NoAddIndices
    Begin Dialog UserDialog 460,309,"Inhomogeneous Film Indices" ' %GRID:5,3,1,1
        GroupBox 30,18,400,51,"Index values",.grpIndex
        Text 50,42,25,15,"Mi&n",.lblMin,1
        TextBox 80,39,65,18,.txtMin
        Text 170,42,35,15,"Ma&x",.lblMax,1
        TextBox 210,39,65,18,.txtMax
        Text 300,42,40,12,"&Steps",.lblSteps,1
        TextBox 345,39,60,18,.txtSteps
        GroupBox 30,81,400,117,"Function",.fraFunc
        ' ********************************************
        '   edit/add user-formula descriptions here
        OptionGroup .grpFunc
            OptionButton 60,102,255,12,"&Linear  n = Min + (k-1)/S * (Max-Min)",.optFuncLin
            OptionButton 60,120,325,12,"&Parabolic n = Min + sqr((k-1)/S * (Max-Min)^2)",.optFuncPar
        ' ********************************************
        Text 45,213,110,15,"Starting sym&bol",.lblSymb,1
        TextBox 165,210,25,18,.txtSymb
        CheckBox 255,213,150,12,"P&hysical thickness",.chkPhysical
        CheckBox 95,240,300,15,"&Add Index Function $N (can be optimized)",.chkOpti
        OKButton 140,270,80,21
        CancelButton 240,270,80,21
    End Dialog
    Dim dlg As UserDialog
    With dlg
        .txtMin = CStr(xMin)
        .txtMax = CStr(xMax)
        .txtSteps = CStr(nStep)
        .txtSymb = Symb1$
        .chkPhysical = kPhys
        .grpFunc = kFunc
        .chkOpti = kOpti
    End With
    Dialog dlg
    With dlg
        xMin = Val(.txtMin)
        xMax = Val(.txtMax)
        nStep = Val(.txtSteps)
        Symb1$ = .txtSymb
        kPhys = .chkPhysical  ' 0 or 1
        kFunc = .grpFunc      ' 0, 1, etc. if more functions defined
        kOpti = .chkOpti
    End With
    GetIndices = True
    Exit Function
NoAddIndices:
    GetIndices=False
    Exit Function
End Function

Sub Parse (strin$, strout$, xout As Variant, ByVal delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub

Function Occurences(ByVal t$, s$) As Integer
    Dim klen&, kpos&, ktot
    klen = Len(s$)  'number of occurences of s$ in t$
    Do
        kpos = InStr(t$, s$)
        If kpos = 0 Then
            Exit Do
        Else
            ktot = ktot + 1
            t$ = Mid$(t$, kpos + klen)
        End If
    Loop
    Occurences = ktot
End Function
