' MonitorWidth1.bas for FilmStar DESIGN
' Copyright 2012-2013 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Adds monochromator bandwidth to R/T vs thickness (monitor) calculations
'
' To run this program As a Macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   Monitor Bandwidth
'   Command       basrun c:\winfilm\basic32\MonitorWidth1.bas;

Public wh!
Option Base 1
Option Explicit
Const zMax! = 1.75, zDel! = .25   ' 15 iterations

Sub Main
    On Error Resume Next    ' in case Cancel pushed
    If MsgBox("Reset FSPlot configuration?", vbYesNo + vbDefaultButton2, "Monitor Bandwidth") = vbYes Then
        PlotClose
        PlotSetup
    End If
    wh = Val(IniString("Monochromator", "Bandwidth"))
    If wh = 0 Then wh = 5
    wh = Val(InputBox("50% bandwidth in nm?", "Optical Monitor Simulation", CStr(wh)))
    If wh > 0 Then
        HighRes
        WriteIniString "Monochromator", "Bandwidth", CStr(wh)
    End If
End Sub

Sub HighRes
    Dim j%, nDat%, yMult!, yMultTot!, w!, wEval!, z!, yDat!(), s$
    StatusLabel "Calculating - please wait"
    PlotClose
    PlotLegendOn True
    PlotLegend(1) = "Bandwidth = " & CStr(wh) & " nm"
    PlotLegend(2) = "Monochromatic"
    PlotTitle = "Optical Monitor Simulation"
    wEval! = EvalWave
    For z = -zMax To zMax Step zDel
        w = wEval + z * wh
        yMult = Exp(-z * z * 2.7726)   ' Gaussian
        yMultTot = yMultTot + yMult
        EvalWave = w
        Calculate
        yDat = Spectrum_Y
        If z = -zMax Then
            nDat = UBound(yDat, 1)
            ReDim yTot(nDat, 2)
        End If
        For j = 1 To nDat
            yTot(j, 1) = yTot(j, 1) + yMult * yDat(j, 1)
            yTot(j, 2) = yTot(j, 2) + yMult * yDat(j, 2)
        Next j
    Next z
    For j = 1 To nDat
        yDat(j, 1) = yTot(j, 1) / yMultTot
        yDat(j, 2) = yTot(j, 2) / yMultTot
    Next j
    StatusLabel ""
    PlotActivate
    Spectrum_Y = yDat
    PlotNext    ' Bandwidth plot
    EvalWave = wEval!   ' Original wavelength
    Calculate
    PlotNext    ' Monochromatic plot
End Sub

Sub PlotSetup
    ' FSPlot graph setup code for FilmStar BASIC:
    PlotConfig 25526465, 2128, 0
    PlotSize 12720, 7590, 74
    PlotTitleFont = "Verdana"
    PlotTitleSize = 110
    PlotLegendSize = 100
    PlotLegendSimple = False
    PlotAxesFont = "Verdana"
    PlotAxesLabelSize = 100
    PlotAxesNumberSize = 100
    PlotFontFixed = False
    PlotFontFixedSize = 1
    PlotAxesConfig = 0
    PlotEdgeSpace 50, -25, 20, 30
    PlotAxesSpace .15, .3, .3, 1.5
    PlotColors "255, 16711680, 57088, 16711935, 8421376, 32896, 0, 8421504, 128, 8388608, 32768, 8388736"
    PlotBitmapMode = False
End Sub
