'#Reference {00020813-0000-0000-C000-000000000046}#1.9#0#C:\Program Files (x86)\Microsoft Office\root\Office16\EXCEL.EXE#Excel
' OharaGlass.bas for FilmStar INDEX
' Copyright 2009-2020 FTG Software Associates
' Revised 05/17/2020
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Generates index table from OharaGlass.xlsm, a modification of
' https://www.oharacorp.com/xls/OHARA_20190718_6.xlsx
'
' n generated from Sellmeier dispersion formula (SELLG)
' k calculated from internal transmittance values
'
' Macro does not require that Excel be open
'
' Following settings recommended for AutoAxes:
'    Setup Parameters: Table type = Index
'          Graph Axes: k-Scale = Log
'
Option Explicit
Dim xlApp As Excel.Application
Dim xlBook As Excel.Workbook
Dim xlSheet As Excel.Worksheet

Sub Main
	Dim s$
    OpenXlsFile PgmPath$ & "\OharaGlass.xlsm"
    xlApp.Run "CopyTable"
    DoEvents
    s$ = xlSheet.Cells(4, 8)
    If s$ <> "" Then
	    IndexPaste
	    AutoAxes True
	    If MsgBox("Save Index Table 'Ohara " & s$ & ".itw'?", vbQuestion + vbYesNo, "Ohara Glass") = vbYes Then FileSave "Ohara " & s$
    End If
    xlApp.Quit
    Set xlSheet = Nothing
    Set xlBook = Nothing
    Set xlApp = Nothing
End Sub

Sub OpenXlsFile(ByVal f$)
	' If you get an error in the next line, you need to re-establish
	' a reference to the Microsoft Excel Object Library
    Set xlApp = New Excel.Application
    Set xlBook = xlApp.Workbooks.Open(f$)
    Set xlSheet = xlBook.Sheets("Export")
    xlApp.DisplayAlerts = False	' no save prompt upon exiting Excel
End Sub



