' PE-SP2.bas for FilmStar DESIGN/MEASURE 32-bit
' Copyright 2001-2005 FTG Software Associates
' 12/08/05...Modified for asc extension now being used
'            by PE UvWinLab
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program opens PE UVWinLab .sp ASCII spectra in FilmStar MEASURE
' It is similar to PE-SP1.bas which re-stores the spectrum in FilmStar.
'
' To exit the program, click Cancel in the file name dialog

DefInt i-N
DefSng A-H, O-Z
Option Explicit
Option Base 1

' ********** Adjust as required **********
'Const ext$ = "sp"      ' old UvWinLab
Const ext$ = "asc"      ' new UvWinLab
' ****************************************

Dim sType$, dName$, fName$, file$, path$

Sub Main
    dName$ = IniString("UVWinLab", "SpcPath")   ' directory name
    OpenFile
    AxesAutoScale True
    WriteIniString "UVWinLab", "SpcPath", dName$
End Sub

Sub OpenFile
    Dim i
    file$ = GetFilePath$(, ext$, dName$, "Open PE spectrum", 0)
    If file$ = "" Then
        End
    Else
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)            ' directory
                fName$ = Right$(file$, Len(file$) - i)
                fName$ = Left$(fName$, Len(fName$) - Len(ext$) - 1) ' file name
                Exit For
            End If
        Next i
        ConvertFile
    End If
End Sub

Sub ConvertFile()
    Dim i, kTyp, nData, xData(), yData(), desc$, dum$, s$
    If fName$ = "" Then Exit Sub
    StatusLabel "Converting " & fName & " - please wait"
    On Error Resume Next
    Open file$ For Input As #1
    For i = 1 To 7
        Line Input #1, s$
    Next i
    Line Input #1, desc$    ' description
    If Len(desc$) > 50 Then desc$ = Left$(desc$,50)
    FileDescription(1) = desc$
    Begin Dialog UserDialog 460,63,"Select Data Type" ' %GRID:10,7,1,1
        OptionGroup .optType
            OptionButton 35,22,120,14,"&Reflectance"
            OptionButton 170,22,120,15,"&Transmittance"
        OKButton 330,21,90,21
    End Dialog
    Dim dlg As UserDialog
    If sType$ = "T" Then dlg.optType = 1
    Dialog dlg
    If dlg.optType = 0 Then sType$ = "R" Else sType$ = "T"
    Do
        Line Input #1, s$
    Loop Until s$ = "#GR"
    For i = 1 To 7      ' skip 6 lines (using line 7)
        Line Input #1, s$
    Next i
    nData = Val(s$)     ' number of points
    Do
        Line Input #1, s$
    Loop Until s$ = "#DATA"
    If InStr(UCase$(PgmExe), "DES") > 0 Then
        ' DESIGN
        If sType$ = "R" Then kTyp = 1 Else kTyp = 2
        ReDim xData(nData), yData(nData, 2)
        For i = 1 To nData
            Line Input #1, s$
            Parse s$, dum$, xData(nData - i + 1), vbTab
            yData(nData - i + 1, kTyp) = .01 * Val(s$)
        Next i
    Else
        ' MEASURE/Scantraq
        ReDim xData(nData), yData(nData)
        For i = 1 To nData
            Line Input #1, s$
            Parse s$, dum$, xData(nData - i + 1), vbTab
            yData(nData - i + 1) = .01 * Val(s$)
        Next i
    End If
    Close #1
    Spectrum_X = xData
    Spectrum_Y = yData
    Replot
    StatusLabel ""
    Busy False
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub

