' RTCombine.bas for FilmStar DESIGN
' Copyright 2009 Software Associates
'
' This program combines (W,R) and (W,T) spectra
' into a DESIGN (W,R,T) spectrum. Its main purpose
' is to import MEASURE spectra.
'
' ****************************************************
'   In MEASURE when saving as .csv (not recommended)
'   check 'DESIGN Format' in Spectra...Format Options'

'    Warning: Save modified program with new name!!!
' ****************************************************
Option Base 1
Option Explicit
DefInt i-N
DefSng A-H, O-Z

' Change if using fewer spectra file extensions
Const Exts$ = "csv;dx;spc;xls"

Sub Main
	Dim i, file$, nDatR, xDatR(), yDatR(), nDatT, xDatT(), yDatT(), yDat()
	FileSave "temp.axw"		' save current graph axes
    file$ = GetFilePath$(, Exts$, FilePath(1), "Open FilmStar MEASURE %R spectrum", 0)
    If file$ = "" Then GoTo Done	' Escape/Cancel
	FileOpen file$
	If LCase$(Right$(file,4))<>".csv" And AxesYtype<>"R" Then
		MsgBox "Not a %R spectrum", vbCritical, "RT Combiner"
    	GoTo Done
    End If
	xDatR = Spectrum_X:	yDatR = Spectrum_Y:	nDatR = UBound(xDatR)
	file$ = GetFilePath$(, Exts$, FilePath(1), "Open FilmStar MEASURE %T spectrum", 0)
	FileOpen file$
	If file$ = "" Then GoTo Done
	' Axes type can change when opening dx/spc/xls spectra
	If LCase$(Right$(file,4))<>".csv" And AxesYtype<>"T" Then
		MsgBox "Not a %T spectrum", vbCritical, "RT Combiner"
    	GoTo Done
    End If
	xDatT = Spectrum_X:	yDatT = Spectrum_Y:	nDatT = UBound(xDatT)
    If nDatR<>nDatT Or xDatR(1)<>xDatT(1) Or xDatR(nDatR)<>xDatT(nDatT) Then
    	MsgBox "Spectra wavelength ranges do not match", vbCritical, "RT Combiner"
    	GoTo Done
    End If
    ReDim yDat(nDatR, 2)
	For i = 1 To nDatR
		yDat(i, 1) = yDatR(i, 1)
		yDat(i, 2) = yDatT(i, 2)
	Next i
	Spectrum_Y = yDat
Done:
	FileOpen "temp.axw"	' restore graph axes
    Busy False
End Sub
