' SetPath.bas for FilmStar DESIGN
' Copyright 2004-2018 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program creates a new ..\Winfilm\NameIt directory
'
' Use this program if you want designs and component
' files (Index optional) in a single directory
'
' Program IniPath.bas restores directories to default values
' BEFORE EXITING DESIGN. Another option for restoring directories
' is DefPath.bas.
'
' Updated 10/26/18
'
Option Explicit
DefInt I-N

Sub Main
    Dim path$, kBrowse As Boolean
    path$ = InputBox("Enter " & PgmPath$ & " subdirectory or '?' to browse", "Set Directory", "")
    If InStr(path$, "?") > 0 Then
        On Error Resume Next
        Dim ShellApp As Object
        Set ShellApp = CreateObject("Shell.Application").BrowseForFolder(0, "Choose " & PgmPath$ & " subdirectory", 0, PgmPath$)
        If ShellApp Is Nothing Then
            End
        Else
            path$ = ShellApp.Self.Name
            Set ShellApp = Nothing
            If Len(path$) > 0 Then path$ = InputBox("Confirm subdirectory", "Set Path", path$)
            kBrowse = True
            If Not DirExists(PgmPath$ & "\" & path$) Then
                MsgBox "Invalid subdirectory", vbCritical, "Set Directory"
                End
            End If
        End If
    End If
    If Len(path$) > 0 Then
        path$ = PgmPath & "\" & path$
        If Not kBrowse Then
            If DirExists(path$) Then
                If MsgBox("Subdirectory already exists; click OK to use it", vbOkCancel, "Set Path") = vbCancel Then End
            Else
                On Error GoTo BadPath
                MkDir path$
            End If
        End If
        Select Case MsgBox("Keep current n,k Tables directory " & FilePath(9) & "?", vbYesNoCancel + vbDefaultButton2, "Set Path")
        Case vbNo
            DefaultPath path$, path$, path$, path$  ' Parameters, Designs, nk Tables, Spectra
        Case vbYes
            DefaultPath path$, path$,, path$        ' Parameters, Designs, Spectra
        Case vbCancel
            End
        End Select
    End If
    End
BadPath:
    MsgBox "Could not create directory " & path$, vbCritical, "Set Path"
    End
End Sub

Function DirExists(ByVal dName$) As Boolean
    Dim sdum$
    On Error Resume Next
    If Right(dName, 1) <> "\" Then dName = dName & "\"
    sdum = Dir$(dName & "*.*", vbDirectory)
    DirExists = Len(sdum) > 0
End Function
