'#Reference {00020813-0000-0000-C000-000000000046}#1.3#0#C:\Program Files\Microsoft Office\Office\EXCEL9.OLB#Microsoft Excel 9.0 Object Library
' SpecCalc5nmXL.bas for FilmStar INDEX
' Copyright 2009 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Similar to SpecCalc5nm.bas, but activates Excel
' window to display all calculated values
' See http://brucelindbloom.com
'
' This macro opens Excel automatically
'
Option Explicit
Option Base 1
Dim xlApp As Excel.Application
Dim xlBook As Excel.Workbook
Dim xlSheet As Excel.Worksheet

'#Uses "ModXLCheck.bas"

Const ttl$ = "Lindbloom Spectral Calculator"
Const fmt$ = "0.00"

Const kType = 1     ' 1 Reflectance  2 Transmittance

Sub Main
	Dim i, ndata, ang!, xdata!(), ydata!()
	On Error GoTo ExcelQuit
	Do
		' 250, 350 specify input box location; adjust as required
		ang = InputBox("Angle of incidence?", "Spectral Calculator", CStr(ang), 250, 350)
		If ang >= 0 And ang < 90 Then
			Angle = ang
			AxesDraw
			CalcPlot
			xdata = Spectrum_X: ydata = Spectrum_Y
			ndata = UBound(xdata)
			If ndata <> 81 Or xdata(1) <> 380 Or xdata(ndata) <> 780 Then
				MsgBox "Not FilmStar CIE range 380-780 x 5 nm", vbCritical, ttl$
				End
			End If
			If Not XLCheck() Then OpenXlsFile PgmPath$ & "\SpectralCalculator5nm.xls"
			With xlSheet
				For i = 10 To 108	' 340 to 830 nm
					If i < 18 Or i > 98 Then
						.Cells(i, 3) = 0
					Else	        ' only use 380-780 nm
						.Cells(i, 3) = ydata(i - 17, kType)
					End If
				Next i
				.Calculate	' recalculate now
			End With
		Else
			MsgBox "Angle cannot be < 0 or > 90 - try again", vbExclamation, ttl
		End If
	Loop
ExcelQuit:
	On Error Resume Next
	xlApp.Quit
    Set xlSheet = Nothing
    Set xlBook = Nothing
    Set xlApp = Nothing
End Sub

Sub OpenXlsFile(ByVal f$)
	' If you get an error in the next line, you need to re-establish
	' a reference to the Microsoft Excel Object Library
	Set xlApp = New Excel.Application
    Set xlBook = xlApp.Workbooks.Open(f$)
    Set xlSheet = xlBook.Sheets(1)
    xlApp.Calculation = xlCalculationManual ' faster
    xlApp.DisplayAlerts = False	' no save prompt upon exiting Excel
    xlApp.Visible = True
End Sub



