' Woollam2 for FilmStar DESIGN, MEASURE
' Copyright 1999-2002 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program opens Woollam .dat spectra in FilmStar. It is similar
' to Woollam1.bas which converts spectra into FilmStar format.
'
' If you have difficulties, check that your Woollam file has
' the same format as sample file UvVisRefl.dat.
'
Option Explicit
Option Base 1
DefInt i-N
DefSng A-H, O-Z
Dim sType$, dName$, fName$, file$

Sub Main
    dName$ = IniString("Woollam", "SpcPath")
    OpenFile
    AxesAutoScale True, True
    WriteIniString "Woollam", "SpcPath", dName$
End Sub

Sub OpenFile
    Dim i
    file$ = GetFilePath$(, "dat", dName$, "Open Woollam spectrum; click Cancel to quit", 0)
    If file$ <> "" Then
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)            ' directory
                fName$ = Right$(file$, Len(file$) - i)
                fName$ = Left$(fName$, Len(fName$) - 4) ' file name
                Exit For
            End If
        Next i
        If fName$ <> "" Then DoImport
    End If
End Sub

Sub DoImport()
    Dim k, kHead, v, vDum, desc$, dum$, s$
    Dim nData, xData(), yData()
    StatusLabel "Converting " & fName & " - please wait"
    On Error Resume Next
    Open file$ For Input As #1
    Line Input #1, desc$
    If Len(desc$) > 50 Then desc$ = Left$(desc$,50)
    kHead = 1
    Do
    	kHead = kHead + 1
        Line Input #1, s$
        If s$ = "nm" Then
            Exit Do         ' Blank line is end of data
        ElseIf kHead > 4 Then
            MsgBox "Data file not in nm", vbCritical, "Import Woollam"
			Close #1
			Exit Sub
        End If
    Loop
    nData = 0
    Do  ' count # of wavelengths in file
		nData = nData + 1
		Line Input #1, s$
	Loop Until EOF(1)
	Close #1
    ReDim sf$(1 To nData)
    Open file$ For Input As #1
    For k = 1 To kHead   ' skip headers
		Line Input #1, s$
	Next k
	For k = 1 To nData
		Line Input #1, sf$(k)
		If k = 1 Then		' get data type
            If Mid$(sf$(k), 2, 1) = "R" Then  ' data type?
                sType$ = "R"	' reflectance
            ElseIf Mid$(sf$(k), 2, 1) = "T" Then
                sType$ = "T"	' transmittance
            Else
                MsgBox "Unknown data type (must be R or T)", vbCritical, "Woollam File Open"
                Close #1
                End
			End If
		End If
    Next k
    Close #1
    If InStr(UCase$(PgmExe), "DES") > 0 Then
        ReDim xData(nData), yData(nData, 2)
    Else
        ReDim xData(nData), yData(nData)
    End If
    FileDescription(1) = desc$
    For k = 1 To nData
        Parse sf$(k), dum$, vDum, vbTab
        Parse sf$(k), dum$, xData(k), vbTab
        Parse sf$(k), dum$, vDum, vbTab ' angle
        Parse sf$(k), dum$, v, vbTab
        If InStr(UCase$(PgmExe), "DES") > 0 Then
            If sType$ = "R" Then
                yData(k, 1) = v
            Else
                yData(k, 2) = v
            End If
        Else
            yData(k) = v
        End If
    Next k
    Spectrum_X = xData
    Spectrum_Y = yData
    Busy False
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub
